"use strict";
const jsxRuntime = require("./jsx-runtime-ec586afa.cjs");
const require$$0 = require("react");
require("./TextInput.component-6c301bc5.cjs");
const TextInput = (props) => {
  const {
    classes,
    containerClasses,
    onBlur,
    onChange,
    onFocus,
    placeholder,
    type
  } = props;
  const [value, setValue] = require$$0.useState();
  const [focussed, setFocussed] = require$$0.useState(false);
  const onLocalChange = (event) => {
    setValue(event.target.value);
    onChange && onChange(event);
  };
  return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs(
    "div",
    {
      className: `c-TextInput position-relative w-100${focussed ? " focussed border-bottom-0" : ""}${containerClasses ? " " + containerClasses : ""}`,
      children: [
        /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(
          "input",
          {
            type: type || "text",
            className: `c-TextInput__input w-100 h-100${classes ? " " + classes : ""}`,
            onChange: onLocalChange,
            onFocus: (...focusHandlerArgs) => {
              setFocussed(true);
              onFocus && onFocus(...focusHandlerArgs);
            },
            onBlur: (...focusHandlerArgs) => {
              setFocussed(false);
              onBlur && onBlur(...focusHandlerArgs);
            },
            placeholder: focussed ? "" : placeholder
          }
        ),
        /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(
          "button",
          {
            className: `c-TextInput__clear-button position-absolute end-0 top-0 d-flex flex-row
          justify-content-center align-items-center h-100 border-0 bg-transparent${value ? " has-value" : ""}${focussed ? " border-bottom-0" : ""}`
          }
        )
      ]
    }
  );
};
module.exports = TextInput;
