"use strict";
const jsxRuntime = require("./jsx-runtime-ec586afa.cjs");
const require$$0 = require("react");
require("./SelectionPill.component-722a55dd.cjs");
require("./Pagination.component-3015b7ff.cjs");
require("./DropDown.component-981da561.cjs");
const Icon = require("./Icon.js");
require("./TextInput.component-6c301bc5.cjs");
const TextInput = require("./TextInput.js");
require("./Widget.component-0657c121.cjs");
require("./Uploader.component-6cb1e4f3.cjs");
require("./TypeAhead.component-641ba779.cjs");
require("./Tooltip.component-febaba12.cjs");
require("./Toolbar.component-88d4e5a2.cjs");
require("./Toggle.component-247847e3.cjs");
require("./TimeEntry.component-1cfb6cd4.cjs");
require("./Mask.component-a69855ea.cjs");
require("./TextArea.component-65ddee91.cjs");
require("./Tag.component-2a02d3da.cjs");
require("./Table.component-0215f4d2.cjs");
require("./TabBar.component-9ef16cca.cjs");
require("./Tab.component-c73e7f2b.cjs");
require("./Splitter.component-f4aa5ab0.cjs");
require("./Slider.component-3b914c9d.cjs");
require("./Select.component-14ba8692.cjs");
require("./SegmentedControl.component-7c0f87d3.cjs");
require("./SecondaryNavigation.component-f85f50bb.cjs");
require("./SearchField.component-70cda0f3.cjs");
require("./Radio.component-42a4d804.cjs");
require("./ProgressStepper.component-16758f3e.cjs");
require("./ProgressIndicator.component-549d2789.cjs");
require("./Popover.component-de42ba62.cjs");
require("./Pillbox.component-20fc4514.cjs");
require("./Pill.component-cdf36cd1.cjs");
require("./Picklist.component-438ed741.cjs");
require("./NumericStepper.component-c5548d74.cjs");
require("./Notification.component-87e8c380.cjs");
require("./Modal.component-683273f4.cjs");
require("./List.component-3115ccf2.cjs");
require("./Link.component-e956b7ea.cjs");
require("./LearnLink.component-f6f39381.cjs");
require("./LabelValue.component-50abeffc.cjs");
require("./InlineMenu.component-9e403a01.cjs");
require("./FacetedFilter.component-c049571f.cjs");
require("./Dialog.component-1632b785.cjs");
require("./DetailsPanel.component-ee23fdd2.cjs");
require("./PickerRange.component-3e143279.cjs");
require("./Calendar.component-e34790a7.cjs");
require("./DateRange.component-c13e7d93.cjs");
require("./DatePicker.component-5faf8919.cjs");
require("./DateInput.component-4604ce42.cjs");
require("./ContextMenu.component-0d249336.cjs");
require("./ColorPicker.component-03713f33.cjs");
require("./Checkbox.component-3eaaedae.cjs");
const Button = require("./Button.js");
require("./BrowserIncompatibility.component-a90b8dbd.cjs");
require("./Breadcrumb.component-a4da12bc.cjs");
require("./Badge.component-60a5b6ec.cjs");
require("./Alert.component-e4b55cff.cjs");
require("./Button.component-d2f92788.cjs");
require("./Icon.component-417c724a.cjs");
class Helper {
  static populateComponentsInRoutes(routes, components) {
    routes && routes.forEach((route) => {
      const Component = components[route.element];
      route.element = /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(Component, {});
      if (route.children) {
        Helper.populateComponentsInRoutes(route.children, components);
      }
    });
  }
  static recrusiveFilter(data, filter, matchCase, searchProps) {
    if (!filter || !data || data.length === 0) {
      return data;
    }
    if (!searchProps || searchProps.length === 0) {
      searchProps = ["label"];
    }
    const dataClone = JSON.parse(JSON.stringify(data));
    const filteredItems = dataClone.filter((obj) => {
      return searchProps && searchProps.reduce((acc, prop) => {
        let isMatch = obj[prop] && (matchCase ? obj[prop].indexOf(filter) > -1 : obj[prop].toLowerCase().indexOf(filter.toLowerCase()) > -1);
        if (obj.children) {
          obj.children = Helper.recrusiveFilter(
            obj.children,
            filter,
            matchCase
          );
          isMatch = isMatch || obj.children.length > 0;
        }
        return acc || isMatch;
      }, false);
    });
    return filteredItems;
  }
  static generateSlices(count, sliceLength, labelFormat) {
    let i = 0, j = 0;
    const slices = [];
    while (i < count) {
      let addUp = sliceLength;
      if (i + sliceLength > count) {
        addUp = count % sliceLength;
      }
      const label = labelFormat === "range" ? i + 1 + " - " + (i + addUp) : "" + (j + 1);
      slices.push(
        /* @__PURE__ */ new Map([
          ["label", label],
          ["name", label.replace(/ /g, "").replace(/-/g, "to")],
          ["sliceIndex", j],
          ["startIndex", i],
          ["endIndex", i + addUp - 1]
        ])
      );
      i += sliceLength;
      j++;
    }
    return slices;
  }
  static aggregate(data, aggregator) {
    let aggregated = /* @__PURE__ */ new Map();
    data.forEach((item) => {
      const key = item[aggregator];
      let aggregatedArray = aggregated.get(key);
      if (!aggregatedArray) {
        aggregatedArray = [];
        aggregated.set(key, aggregatedArray);
      }
      aggregatedArray.push(item);
    });
    return aggregated;
  }
  static generateCategories(data, categories) {
    const groups = /* @__PURE__ */ new Map();
    if (categories && data) {
      categories.forEach((key) => {
        let group = Helper.aggregate(data, key);
        groups.set(key, group);
      });
    }
    return groups;
  }
  static toCamelCase(str, separater, includeFirst) {
    const strParts = str.split(separater || " ");
    return strParts.map(
      (part, i) => i === 0 && includeFirst ? part.charAt(0).toUpperCase() + part.slice(1) : part
    ).join("");
  }
}
const generateRenders = (data, i, onItemSelect) => {
  return data && /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx("ul", { className: `c-TreeList__list list-unstyled`, children: data.map((obj, index) => /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(
    TreeListItem,
    {
      hierarchyLevel: i,
      data: obj,
      onItemSelect
    },
    "TreeListItem" + index
  )) });
};
const TreeListItem = (props) => {
  const { hierarchyLevel, data, onItemSelect } = props;
  const [expanded, setExpanded] = require$$0.useState(data.expanded);
  let children = null;
  if (data.children) {
    children = generateRenders(data.children, hierarchyLevel + 1, onItemSelect);
  }
  const handleItemClick = () => {
    data.onItemSelect && data.onItemSelect(data);
    if (onItemSelect && !data.skipParentSelector) {
      onItemSelect(data);
    } else {
      console.warn(
        "Parent Selector not called due to the tree item property skipParentSelector!"
      );
    }
    children && setExpanded(!expanded);
  };
  return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs("li", { className: `c-TreeListItem${!expanded ? " expanded" : ""}`, children: [
    /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs(
      "span",
      {
        className: "d-inline-block py-2 w-100",
        style: {
          paddingLeft: hierarchyLevel > 0 ? 1.25 + 0.8 * hierarchyLevel + "rem" : 0
        },
        onClick: handleItemClick,
        children: [
          children && /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(
            Icon,
            {
              containerClasses: "me-1",
              src: "http://localhost:8080/icon/md/MdKeyboardArrowRight"
            }
          ),
          data.label
        ]
      }
    ),
    children
  ] });
};
const TreeList = (props) => {
  const { data, firstExpanded, noSearch, onItemSelect, title } = props;
  const [filteredItems, setFilteredItems] = require$$0.useState();
  firstExpanded && data && data[0] && (data[0].expanded = true);
  return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs("div", { className: "c-TreeList mx-1", children: [
    title && /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx("strong", { className: "d-block mb-3 mt-2", children: title }),
    !noSearch && /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(
      Search,
      {
        data,
        onChange: (e, filteredItems2) => setFilteredItems(filteredItems2)
      }
    ),
    generateRenders(filteredItems || data, 0, onItemSelect)
  ] });
};
const Search = (props) => {
  const { classes, data, placeholder } = props;
  const onChange = "onChange" in props && props.onChange;
  const showPopUp = "showPopUp" in props && props.showPopUp;
  const [filteredItems, setFilteredItems] = require$$0.useState();
  const [focusClass, setFocusClass] = require$$0.useState("");
  const onLocalChange = (event) => {
    if (showPopUp) {
      const filteredItems2 = Helper.recrusiveFilter(
        data,
        event.target.value,
        false,
        ["label"]
      );
      setFilteredItems(filteredItems2);
      onChange && onChange(event, filteredItems2);
    } else {
      onChange && onChange(event, null);
    }
  };
  const filteredItemsRenders = filteredItems && filteredItems.map((item) => {
    return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx("div", {});
  });
  return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs(
    "div",
    {
      className: `c-Search d-flex w-100 position-relative ${focusClass}${classes ? " " + classes : ""}`,
      children: [
        /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(
          TextInput,
          {
            containerClasses: "form-component",
            classes: "c-Search__input p-1 bg-transparent border-0",
            onBlur: () => setFocusClass(""),
            onChange: onLocalChange,
            onFocus: () => setFocusClass("focussed"),
            placeholder: placeholder || "Search",
            type: "text"
          }
        ),
        /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(
          Button,
          {
            content: /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(Icon, { src: "http://localhost:8080/icon/ai/AiOutlineSearch" }),
            classes: `search-button bg-transparent form-component${focusClass ? " border-bottom-0" : ""}`
          }
        ),
        (!onChange || showPopUp) && /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(
          "div",
          {
            className: `c-Search__search-results p-3 position-absolute top-100 start-0 w-100 bg-white border${focusClass ? "" : " h-0 overflow-hidden"}${filteredItemsRenders ? "" : " flex-center"}`,
            onClick: (e) => e.stopPropagation(),
            children: filteredItemsRenders || /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx("i", { children: "Type to view results here" })
          }
        )
      ]
    }
  );
};
module.exports = TreeList;
