import { j as jsxRuntimeExports } from "./jsx-runtime-5a50c612.js";
import { useState } from "react";
import "./AlphabetFilter.component-6891be70.js";
import CategoryFilter from "./CategoryFilter.js";
import AlphabetFilter from "./AlphabetFilter.js";
import "./Users.component-471e19e0.js";
import "./Toast.component-2c91db7d.js";
import "./Testimonials.component-d89149a0.js";
import "./Team.component-e54f3f3c.js";
import "./Steps.component-fb614ec4.js";
import "./Stats.component-b52e2043.js";
import "./Snackbar.component-1f40b80f.js";
import "./SignInUp.component-60aa0bd7.js";
import "./Services.component-f17ec135.js";
import { H as Helper } from "./helper-6a654f8c.js";
import "./RichText.component-8c13163e.js";
import "./Reviews.component-2c041df5.js";
import "./Projects.component-4995023a.js";
import "./ProductInfo.component-6f4f0c4e.js";
import "./Pricing.component-c2d76578.js";
import "./Portfolio.component-0c3d2226.js";
import "./Notifications.component-2e7a825b.js";
import "./Newsletter.component-52531f4a.js";
import "./LogoClouds.component-bd581c43.js";
import "./Integrations.component-f49f3bee.js";
import "./InstaPhotos.component-6c3354ca.js";
import "./HowItWorks.component-ba9d9c22.js";
import "./Hero.component-addb168a.js";
import "./HttpCode.component-e0447052.js";
import "./Graph.component-dc7e23cf.js";
import "./GraphTiles.component-dac88886.js";
import "./Gallery.component-ff108003.js";
import "./Form.component-62eb5c58.js";
import "./Footer.component-2a844a60.js";
import "./Features.component-ae834147.js";
import "./Faq.component-33d5b133.js";
import "./Empty.component-c9aaf811.js";
import "./EcommProducts.component-acad1653.js";
import "./EcommOrders.component-1a424b01.js";
import "./Download.component-ddc16bd8.js";
import "./Dashboard.component-9ed086ac.js";
import "./Cookies.component-3b3e68b5.js";
import "./Content.component-5ccc42e8.js";
import "./Contact.component-ce5e0d0d.js";
import "./Careers.component-0d4ad0db.js";
import "./Card.component-49af79be.js";
import "./Cta.component-4b2a1643.js";
import "./Breadcrumbs.component-227f2f6c.js";
import "./Brands.component-b13c37b2.js";
import "./Blog.component-fba44e7a.js";
import "./Benefits.component-b71943a6.js";
import "./Banner.component-dbfc7209.js";
import "./Application.component-4340eb78.js";
import "./AboutUs.component-1dcbbd07.js";
import "./SelectionPill-27c278d7.js";
const DropDown = (props) => {
  const { context, id, label, onSelectionChanged, options } = props;
  const [value, setValue] = useState();
  const onLocalChange = (e) => {
    setValue(e.target.value);
    onSelectionChanged && onSelectionChanged(
      {
        value: e.target.value,
        data: options.find(
          (o) => (o.get("name") || o.get("label")) === e.target.value
        )
      },
      context
    );
  };
  return /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { className: "c-DropDown w-100 mb-3", children: [
    label && /* @__PURE__ */ jsxRuntimeExports.jsx("label", { className: "c-DropDown__label label", htmlFor: id, children: label }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(
      "select",
      {
        id,
        className: "c-DropDown__select form-component px-3 py-2 w-100",
        onChange: onLocalChange,
        children: options.map((option) => /* @__PURE__ */ jsxRuntimeExports.jsx("option", { value: option.get("name") || option.get("label"), children: option.get("label") }))
      }
    )
  ] });
};
const Filters = (props) => {
  const { config, data, initialFilters, onFilterChange } = props;
  const [filters, setFilters] = useState(
    initialFilters
  );
  const total = data && data.length;
  const countOptions = Helper.generateSlices(
    total || 0,
    config.count || 0,
    "range"
  );
  const onLocalFilterChange = (data2, type) => {
    const filterClone = filters ? { ...filters } : {};
    const existing = filterClone[type];
    if (existing && type !== "count" && data2 && type === "alphabet" && "value" in existing && "value" in data2 && existing.value === data2.value) {
      filterClone[type] = void 0;
    } else {
      filterClone[type] = data2;
    }
    setFilters(filterClone);
    onFilterChange && onFilterChange(filterClone);
  };
  return /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { className: "c-Filters p-3 h-100 overflow-auto", children: [
    /* @__PURE__ */ jsxRuntimeExports.jsx("h4", { children: "Filters" }),
    "count" in config && /* @__PURE__ */ jsxRuntimeExports.jsx(
      DropDown,
      {
        context: "count",
        id: "icon-range-selector",
        label: "Select a range",
        options: countOptions,
        onSelectionChanged: (data2) => {
          onLocalFilterChange(data2, "count");
        }
      }
    ),
    config.alphabet && /* @__PURE__ */ jsxRuntimeExports.jsx(AlphabetFilter, { onSelectionChanged: onLocalFilterChange }),
    "categories" in config && /* @__PURE__ */ jsxRuntimeExports.jsx(
      CategoryFilter,
      {
        categoryGroups: Helper.generateCategories(data, config.categories),
        onCategorySelection: (data2, category) => {
          const categories = filters && filters.categories ? filters.categories : /* @__PURE__ */ new Map();
          "set" in categories && categories.set(category, data2);
          onLocalFilterChange(categories, "categories");
        }
      }
    )
  ] });
};
export {
  Filters as default
};
