import { j as jsxRuntimeExports } from "./jsx-runtime-5a50c612.js";
class Helper {
  static populateComponentsInRoutes(routes, components) {
    routes && routes.forEach((route) => {
      const Component = components[route.element];
      route.element = /* @__PURE__ */ jsxRuntimeExports.jsx(Component, {});
      if (route.children) {
        Helper.populateComponentsInRoutes(route.children, components);
      }
    });
  }
  static recrusiveFilter(data, filter, matchCase, searchProps) {
    if (!filter || !data || data.length === 0) {
      return data;
    }
    if (!searchProps || searchProps.length === 0) {
      searchProps = ["label"];
    }
    const dataClone = JSON.parse(JSON.stringify(data));
    const filteredItems = dataClone.filter((obj) => {
      return searchProps && searchProps.reduce((acc, prop) => {
        let isMatch = obj[prop] && (matchCase ? obj[prop].indexOf(filter) > -1 : obj[prop].toLowerCase().indexOf(filter.toLowerCase()) > -1);
        if (obj.children) {
          obj.children = Helper.recrusiveFilter(
            obj.children,
            filter,
            matchCase
          );
          isMatch = isMatch || obj.children.length > 0;
        }
        return acc || isMatch;
      }, false);
    });
    return filteredItems;
  }
  static generateSlices(count, sliceLength, labelFormat) {
    let i = 0, j = 0;
    const slices = [];
    while (i < count) {
      let addUp = sliceLength;
      if (i + sliceLength > count) {
        addUp = count % sliceLength;
      }
      const label = labelFormat === "range" ? i + 1 + " - " + (i + addUp) : "" + (j + 1);
      slices.push(
        /* @__PURE__ */ new Map([
          ["label", label],
          ["name", label.replace(/ /g, "").replace(/-/g, "to")],
          ["sliceIndex", j],
          ["startIndex", i],
          ["endIndex", i + addUp - 1]
        ])
      );
      i += sliceLength;
      j++;
    }
    return slices;
  }
  static aggregate(data, aggregator) {
    let aggregated = /* @__PURE__ */ new Map();
    data.forEach((item) => {
      const key = item[aggregator];
      let aggregatedArray = aggregated.get(key);
      if (!aggregatedArray) {
        aggregatedArray = [];
        aggregated.set(key, aggregatedArray);
      }
      aggregatedArray.push(item);
    });
    return aggregated;
  }
  static generateCategories(data, categories) {
    const groups = /* @__PURE__ */ new Map();
    if (categories && data) {
      categories.forEach((key) => {
        let group = Helper.aggregate(data, key);
        groups.set(key, group);
      });
    }
    return groups;
  }
  static toCamelCase(str, separater, includeFirst) {
    const strParts = str.split(separater || " ");
    return strParts.map(
      (part, i) => i === 0 && includeFirst ? part.charAt(0).toUpperCase() + part.slice(1) : part
    ).join("");
  }
}
export {
  Helper as H
};
